/* board-view-clutter.c generated by valac 0.48.6, the Vala compiler
 * generated from board-view-clutter.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <clutter/clutter.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define TYPE_LIGHT (light_get_type ())
#define LIGHT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIGHT, Light))
#define LIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIGHT, LightClass))
#define IS_LIGHT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIGHT))
#define IS_LIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIGHT))
#define LIGHT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIGHT, LightClass))

typedef struct _Light Light;
typedef struct _LightClass LightClass;
typedef struct _LightPrivate LightPrivate;
enum  {
	LIGHT_0_PROPERTY,
	LIGHT_IS_LIT_PROPERTY,
	LIGHT_NUM_PROPERTIES
};
static GParamSpec* light_properties[LIGHT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOARD_VIEW (board_view_get_type ())
#define BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW, BoardView))
#define IS_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW))
#define BOARD_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BOARD_VIEW, BoardViewIface))

typedef struct _BoardView BoardView;
typedef struct _BoardViewIface BoardViewIface;

#define TYPE_PUZZLE_GENERATOR (puzzle_generator_get_type ())
#define PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGenerator))
#define PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))
#define IS_PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_GENERATOR))
#define IS_PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_GENERATOR))
#define PUZZLE_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))

typedef struct _PuzzleGenerator PuzzleGenerator;
typedef struct _PuzzleGeneratorClass PuzzleGeneratorClass;

#define TYPE_BOARD_VIEW_CLUTTER (board_view_clutter_get_type ())
#define BOARD_VIEW_CLUTTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW_CLUTTER, BoardViewClutter))
#define BOARD_VIEW_CLUTTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD_VIEW_CLUTTER, BoardViewClutterClass))
#define IS_BOARD_VIEW_CLUTTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW_CLUTTER))
#define IS_BOARD_VIEW_CLUTTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD_VIEW_CLUTTER))
#define BOARD_VIEW_CLUTTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD_VIEW_CLUTTER, BoardViewClutterClass))

typedef struct _BoardViewClutter BoardViewClutter;
typedef struct _BoardViewClutterClass BoardViewClutterClass;
typedef struct _BoardViewClutterPrivate BoardViewClutterPrivate;
enum  {
	BOARD_VIEW_CLUTTER_0_PROPERTY,
	BOARD_VIEW_CLUTTER_MOVES_PROPERTY,
	BOARD_VIEW_CLUTTER_NUM_PROPERTIES
};
static GParamSpec* board_view_clutter_properties[BOARD_VIEW_CLUTTER_NUM_PROPERTIES];

struct _Light {
	ClutterGroup parent_instance;
	LightPrivate * priv;
};

struct _LightClass {
	ClutterGroupClass parent_class;
};

struct _LightPrivate {
	ClutterActor* off;
	ClutterActor* on;
	gboolean _is_lit;
};

struct _BoardViewIface {
	GTypeInterface parent_iface;
	gint (*get_moves) (BoardView* self);
	PuzzleGenerator* (*get_puzzle_generator) (BoardView* self);
	void (*clear_level) (BoardView* self);
	void (*toggle_light) (BoardView* self, gint x, gint y, gboolean user_initiated);
	void (*increase_moves) (BoardView* self);
	gboolean (*is_light_active) (BoardView* self, gint x, gint y);
	GObject* (*get_light_at) (BoardView* self, gint x, gint y);
};

struct _BoardViewClutter {
	ClutterGroup parent_instance;
	BoardViewClutterPrivate * priv;
	gboolean playable;
};

struct _BoardViewClutterClass {
	ClutterGroupClass parent_class;
};

struct _BoardViewClutterPrivate {
	PuzzleGenerator* puzzle_generator;
	gint _moves;
	ClutterActor* off_texture;
	ClutterActor* on_texture;
	Light** lights;
	gint lights_length1;
	gint lights_length2;
};

static gint Light_private_offset;
static gpointer light_parent_class = NULL;
static gint BoardViewClutter_private_offset;
static gpointer board_view_clutter_parent_class = NULL;
static BoardViewIface * board_view_clutter_board_view_parent_iface = NULL;

GType light_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Light, g_object_unref)
#define LIGHT_SCALE_OFF 0.9
#define LIGHT_SCALE_ON 1.0
Light* light_new (ClutterActor* off_actor,
                  ClutterActor* on_actor);
Light* light_construct (GType object_type,
                        ClutterActor* off_actor,
                        ClutterActor* on_actor);
void light_toggle_pixel (Light* self,
                         ClutterTimeline* timeline);
gboolean light_get_is_lit (Light* self);
void light_set_is_lit (Light* self,
                       gboolean value);
static void light_finalize (GObject * obj);
static GType light_get_type_once (void);
static void _vala_light_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_light_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
GType puzzle_generator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleGenerator, g_object_unref)
GType board_view_get_type (void) G_GNUC_CONST;
GType board_view_clutter_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoardViewClutter, g_object_unref)
static gint board_view_clutter_real_get_moves (BoardView* base);
BoardViewClutter* board_view_clutter_new (ClutterActor* off_texture,
                                          ClutterActor* on_texture);
BoardViewClutter* board_view_clutter_construct (GType object_type,
                                                ClutterActor* off_texture,
                                                ClutterActor* on_texture);
#define BOARD_VIEW_size 5
PuzzleGenerator* puzzle_generator_new (gint size);
PuzzleGenerator* puzzle_generator_construct (GType object_type,
                                             gint size);
static void ________lambda4_ (BoardViewClutter* self,
                       ClutterTapAction* tap,
                       ClutterActor* actor);
void board_view_handle_toggle (BoardView* self,
                               GObject* light);
static void _________lambda4__clutter_tap_action_tap (ClutterTapAction* _sender,
                                               ClutterActor* actor,
                                               gpointer self);
void board_view_clutter_get_light_position (BoardViewClutter* self,
                                            gint x,
                                            gint y,
                                            gfloat* xx,
                                            gfloat* yy);
void board_view_clutter_slide_in (BoardViewClutter* self,
                                  gint direction,
                                  gint sign,
                                  ClutterTimeline* timeline);
void board_view_clutter_slide_out (BoardViewClutter* self,
                                   gint direction,
                                   gint sign,
                                   ClutterTimeline* timeline);
static void board_view_clutter_real_toggle_light (BoardView* base,
                                           gint x,
                                           gint y,
                                           gboolean animate);
static PuzzleGenerator* board_view_clutter_real_get_puzzle_generator (BoardView* base);
static void board_view_clutter_real_clear_level (BoardView* base);
static gboolean board_view_clutter_real_is_light_active (BoardView* base,
                                                  gint x,
                                                  gint y);
static GObject* board_view_clutter_real_get_light_at (BoardView* base,
                                               gint x,
                                               gint y);
static void board_view_clutter_real_increase_moves (BoardView* base);
gint board_view_clutter_get_moves (BoardViewClutter* self);
static void board_view_clutter_finalize (GObject * obj);
static GType board_view_clutter_get_type_once (void);
static void _vala_board_view_clutter_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
light_get_instance_private (Light* self)
{
	return G_STRUCT_MEMBER_P (self, Light_private_offset);
}

Light*
light_construct (GType object_type,
                 ClutterActor* off_actor,
                 ClutterActor* on_actor)
{
	Light * self = NULL;
	ClutterClone* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterClone* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	ClutterActor* _tmp8_;
	ClutterActor* _tmp9_;
	ClutterActor* _tmp10_;
	ClutterActor* _tmp11_;
	ClutterActor* _tmp12_;
	g_return_val_if_fail (off_actor != NULL, NULL);
	g_return_val_if_fail (on_actor != NULL, NULL);
	self = (Light*) g_object_new (object_type, NULL);
	clutter_actor_set_scale ((ClutterActor*) self, LIGHT_SCALE_OFF, LIGHT_SCALE_OFF);
	_tmp0_ = (ClutterClone*) clutter_clone_new (off_actor);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->off);
	self->priv->off = (ClutterActor*) _tmp0_;
	_tmp1_ = self->priv->off;
	clutter_actor_set_pivot_point (_tmp1_, 0.5f, 0.5f);
	_tmp2_ = self->priv->off;
	clutter_actor_add_child ((ClutterActor*) self, _tmp2_);
	_tmp3_ = (ClutterClone*) clutter_clone_new (on_actor);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->on);
	self->priv->on = (ClutterActor*) _tmp3_;
	_tmp4_ = self->priv->on;
	clutter_actor_set_pivot_point (_tmp4_, 0.5f, 0.5f);
	_tmp5_ = self->priv->on;
	clutter_actor_set_opacity (_tmp5_, (guint) 0);
	_tmp6_ = self->priv->on;
	clutter_actor_add_child ((ClutterActor*) self, _tmp6_);
	_tmp7_ = self->priv->off;
	clutter_actor_set_position (_tmp7_, (gfloat) 2, (gfloat) 2);
	_tmp8_ = self->priv->on;
	clutter_actor_set_position (_tmp8_, (gfloat) 2, (gfloat) 2);
	_tmp9_ = self->priv->off;
	clutter_actor_set_easing_duration (_tmp9_, (guint) 300);
	_tmp10_ = self->priv->on;
	clutter_actor_set_easing_duration (_tmp10_, (guint) 300);
	_tmp11_ = self->priv->off;
	clutter_actor_set_easing_mode (_tmp11_, CLUTTER_EASE_OUT_SINE);
	_tmp12_ = self->priv->on;
	clutter_actor_set_easing_mode (_tmp12_, CLUTTER_EASE_OUT_SINE);
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) 300);
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_OUT_SINE);
	return self;
}

Light*
light_new (ClutterActor* off_actor,
           ClutterActor* on_actor)
{
	return light_construct (TYPE_LIGHT, off_actor, on_actor);
}

void
light_toggle_pixel (Light* self,
                    ClutterTimeline* timeline)
{
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ClutterActor* _tmp3_;
	gint _tmp4_ = 0;
	gboolean _tmp5_;
	gboolean _tmp6_;
	ClutterActor* _tmp7_;
	gdouble _tmp8_ = 0.0;
	gboolean _tmp9_;
	gboolean _tmp10_;
	gdouble _tmp11_ = 0.0;
	gboolean _tmp12_;
	gboolean _tmp13_;
	g_return_if_fail (self != NULL);
	self->priv->_is_lit = !self->priv->_is_lit;
	clutter_actor_save_easing_state ((ClutterActor*) self);
	if (timeline == NULL) {
		clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) 0);
	}
	_tmp1_ = light_get_is_lit (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = 0;
	} else {
		_tmp0_ = 255;
	}
	_tmp3_ = self->priv->off;
	clutter_actor_set_opacity (_tmp3_, (guint8) _tmp0_);
	_tmp5_ = light_get_is_lit (self);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		_tmp4_ = 255;
	} else {
		_tmp4_ = 0;
	}
	_tmp7_ = self->priv->on;
	clutter_actor_set_opacity (_tmp7_, (guint8) _tmp4_);
	_tmp9_ = light_get_is_lit (self);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		_tmp8_ = LIGHT_SCALE_ON;
	} else {
		_tmp8_ = LIGHT_SCALE_OFF;
	}
	_tmp12_ = light_get_is_lit (self);
	_tmp13_ = _tmp12_;
	if (_tmp13_) {
		_tmp11_ = LIGHT_SCALE_ON;
	} else {
		_tmp11_ = LIGHT_SCALE_OFF;
	}
	clutter_actor_set_scale ((ClutterActor*) self, _tmp8_, _tmp11_);
	clutter_actor_restore_easing_state ((ClutterActor*) self);
}

gboolean
light_get_is_lit (Light* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_lit;
	return result;
}

void
light_set_is_lit (Light* self,
                  gboolean value)
{
	g_return_if_fail (self != NULL);
	value = value != FALSE;
	if (value != self->priv->_is_lit) {
		light_toggle_pixel (self, NULL);
	}
	g_object_notify_by_pspec ((GObject *) self, light_properties[LIGHT_IS_LIT_PROPERTY]);
}

static void
light_class_init (LightClass * klass,
                  gpointer klass_data)
{
	light_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Light_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_light_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_light_set_property;
	G_OBJECT_CLASS (klass)->finalize = light_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIGHT_IS_LIT_PROPERTY, light_properties[LIGHT_IS_LIT_PROPERTY] = g_param_spec_boolean ("is-lit", "is-lit", "is-lit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
light_instance_init (Light * self,
                     gpointer klass)
{
	self->priv = light_get_instance_private (self);
}

static void
light_finalize (GObject * obj)
{
	Light * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIGHT, Light);
	_g_object_unref0 (self->priv->off);
	_g_object_unref0 (self->priv->on);
	G_OBJECT_CLASS (light_parent_class)->finalize (obj);
}

static GType
light_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LightClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) light_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Light), 0, (GInstanceInitFunc) light_instance_init, NULL };
	GType light_type_id;
	light_type_id = g_type_register_static (clutter_group_get_type (), "Light", &g_define_type_info, 0);
	Light_private_offset = g_type_add_instance_private (light_type_id, sizeof (LightPrivate));
	return light_type_id;
}

GType
light_get_type (void)
{
	static volatile gsize light_type_id__volatile = 0;
	if (g_once_init_enter (&light_type_id__volatile)) {
		GType light_type_id;
		light_type_id = light_get_type_once ();
		g_once_init_leave (&light_type_id__volatile, light_type_id);
	}
	return light_type_id__volatile;
}

static void
_vala_light_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Light * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LIGHT, Light);
	switch (property_id) {
		case LIGHT_IS_LIT_PROPERTY:
		g_value_set_boolean (value, light_get_is_lit (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_light_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Light * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LIGHT, Light);
	switch (property_id) {
		case LIGHT_IS_LIT_PROPERTY:
		light_set_is_lit (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
board_view_clutter_get_instance_private (BoardViewClutter* self)
{
	return G_STRUCT_MEMBER_P (self, BoardViewClutter_private_offset);
}

static gint
board_view_clutter_real_get_moves (BoardView* base)
{
	BoardViewClutter * self;
	gint result = 0;
	self = (BoardViewClutter*) base;
	result = self->priv->_moves;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
________lambda4_ (BoardViewClutter* self,
                  ClutterTapAction* tap,
                  ClutterActor* actor)
{
	g_return_if_fail (tap != NULL);
	g_return_if_fail (actor != NULL);
	board_view_handle_toggle ((BoardView*) self, (GObject*) actor);
}

static void
_________lambda4__clutter_tap_action_tap (ClutterTapAction* _sender,
                                          ClutterActor* actor,
                                          gpointer self)
{
	________lambda4_ ((BoardViewClutter*) self, _sender, actor);
}

BoardViewClutter*
board_view_clutter_construct (GType object_type,
                              ClutterActor* off_texture,
                              ClutterActor* on_texture)
{
	BoardViewClutter * self = NULL;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	PuzzleGenerator* _tmp2_;
	Light** _tmp3_;
	g_return_val_if_fail (off_texture != NULL, NULL);
	g_return_val_if_fail (on_texture != NULL, NULL);
	self = (BoardViewClutter*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (off_texture);
	_g_object_unref0 (self->priv->off_texture);
	self->priv->off_texture = _tmp0_;
	_tmp1_ = _g_object_ref0 (on_texture);
	_g_object_unref0 (self->priv->on_texture);
	self->priv->on_texture = _tmp1_;
	_tmp2_ = puzzle_generator_new (BOARD_VIEW_size);
	_g_object_unref0 (self->priv->puzzle_generator);
	self->priv->puzzle_generator = _tmp2_;
	_tmp3_ = g_new0 (Light*, (BOARD_VIEW_size * BOARD_VIEW_size) + 1);
	self->priv->lights = (_vala_array_free (self->priv->lights, self->priv->lights_length1 * self->priv->lights_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->lights = _tmp3_;
	self->priv->lights_length1 = BOARD_VIEW_size;
	self->priv->lights_length2 = BOARD_VIEW_size;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = x;
					x = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (!(x < BOARD_VIEW_size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							Light* l = NULL;
							Light* _tmp8_;
							Light* _tmp9_;
							ClutterTapAction* tap = NULL;
							ClutterTapAction* _tmp10_;
							Light* _tmp11_;
							ClutterTapAction* _tmp12_;
							ClutterTapAction* _tmp13_;
							gfloat xx = 0.0F;
							gfloat yy = 0.0F;
							gfloat _tmp14_ = 0.0F;
							gfloat _tmp15_ = 0.0F;
							Light* _tmp16_;
							Light* _tmp17_;
							Light** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							Light* _tmp19_;
							Light* _tmp20_;
							Light* _tmp21_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = y;
								y = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							if (!(y < BOARD_VIEW_size)) {
								break;
							}
							_tmp8_ = light_new (off_texture, on_texture);
							g_object_ref_sink (_tmp8_);
							l = _tmp8_;
							_tmp9_ = l;
							clutter_actor_set_reactive ((ClutterActor*) _tmp9_, TRUE);
							_tmp10_ = (ClutterTapAction*) clutter_tap_action_new ();
							g_object_ref_sink (_tmp10_);
							tap = _tmp10_;
							_tmp11_ = l;
							_tmp12_ = tap;
							clutter_actor_add_action ((ClutterActor*) _tmp11_, (ClutterAction*) _tmp12_);
							_tmp13_ = tap;
							g_signal_connect_object (_tmp13_, "tap", (GCallback) _________lambda4__clutter_tap_action_tap, self, 0);
							board_view_clutter_get_light_position (self, x, y, &_tmp14_, &_tmp15_);
							xx = _tmp14_;
							yy = _tmp15_;
							_tmp16_ = l;
							clutter_actor_set_pivot_point ((ClutterActor*) _tmp16_, 0.5f, 0.5f);
							_tmp17_ = l;
							clutter_actor_set_position ((ClutterActor*) _tmp17_, xx, yy);
							_tmp18_ = self->priv->lights;
							_tmp18__length1 = self->priv->lights_length1;
							_tmp18__length2 = self->priv->lights_length2;
							_tmp19_ = l;
							_tmp20_ = _g_object_ref0 (_tmp19_);
							_g_object_unref0 (_tmp18_[(x * _tmp18__length2) + y]);
							_tmp18_[(x * _tmp18__length2) + y] = _tmp20_;
							_tmp21_ = l;
							clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp21_);
							_g_object_unref0 (tap);
							_g_object_unref0 (l);
						}
					}
				}
			}
		}
	}
	self->priv->_moves = 0;
	return self;
}

BoardViewClutter*
board_view_clutter_new (ClutterActor* off_texture,
                        ClutterActor* on_texture)
{
	return board_view_clutter_construct (TYPE_BOARD_VIEW_CLUTTER, off_texture, on_texture);
}

void
board_view_clutter_get_light_position (BoardViewClutter* self,
                                       gint x,
                                       gint y,
                                       gfloat* xx,
                                       gfloat* yy)
{
	gfloat _vala_xx = 0.0F;
	gfloat _vala_yy = 0.0F;
	ClutterActor* _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	ClutterActor* _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->off_texture;
	_tmp1_ = clutter_actor_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	_vala_xx = x * _tmp2_;
	_tmp3_ = self->priv->off_texture;
	_tmp4_ = clutter_actor_get_height (_tmp3_);
	_tmp5_ = _tmp4_;
	_vala_yy = y * _tmp5_;
	if (xx) {
		*xx = _vala_xx;
	}
	if (yy) {
		*yy = _vala_yy;
	}
}

void
board_view_clutter_slide_in (BoardViewClutter* self,
                             gint direction,
                             gint sign,
                             ClutterTimeline* timeline)
{
	gfloat _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (timeline != NULL);
	_tmp0_ = clutter_actor_get_width ((ClutterActor*) self);
	_tmp1_ = _tmp0_;
	clutter_actor_set_x ((ClutterActor*) self, ((-sign) * direction) * _tmp1_);
	_tmp2_ = clutter_actor_get_height ((ClutterActor*) self);
	_tmp3_ = _tmp2_;
	clutter_actor_set_y ((ClutterActor*) self, ((-sign) * (1 - direction)) * _tmp3_);
	clutter_actor_animate_with_timeline ((ClutterActor*) self, (gulong) CLUTTER_EASE_OUT_BOUNCE, timeline, "x", 0.0, "y", 0.0, NULL);
}

void
board_view_clutter_slide_out (BoardViewClutter* self,
                              gint direction,
                              gint sign,
                              ClutterTimeline* timeline)
{
	gfloat _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (timeline != NULL);
	_tmp0_ = clutter_actor_get_width ((ClutterActor*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = clutter_actor_get_height ((ClutterActor*) self);
	_tmp3_ = _tmp2_;
	clutter_actor_animate_with_timeline ((ClutterActor*) self, (gulong) CLUTTER_EASE_OUT_BOUNCE, timeline, "x", (sign * direction) * _tmp1_, "y", (sign * (1 - direction)) * _tmp3_, NULL);
}

static void
board_view_clutter_real_toggle_light (BoardView* base,
                                      gint x,
                                      gint y,
                                      gboolean animate)
{
	BoardViewClutter * self;
	ClutterTimeline* timeline = NULL;
	Light** _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	Light* _tmp14_;
	ClutterTimeline* _tmp15_;
	self = (BoardViewClutter*) base;
	if (!self->playable) {
		return;
	}
	timeline = NULL;
	if (animate) {
		ClutterTimeline* _tmp0_;
		_tmp0_ = clutter_timeline_new ((guint) 300);
		_g_object_unref0 (timeline);
		timeline = _tmp0_;
	}
	if ((((gint) x) + 1) < BOARD_VIEW_size) {
		Light** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		Light* _tmp2_;
		ClutterTimeline* _tmp3_;
		_tmp1_ = self->priv->lights;
		_tmp1__length1 = self->priv->lights_length1;
		_tmp1__length2 = self->priv->lights_length2;
		_tmp2_ = _tmp1_[((((gint) x) + 1) * _tmp1__length2) + ((gint) y)];
		_tmp3_ = timeline;
		light_toggle_pixel (_tmp2_, _tmp3_);
	}
	if ((((gint) x) - 1) >= 0) {
		Light** _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		Light* _tmp5_;
		ClutterTimeline* _tmp6_;
		_tmp4_ = self->priv->lights;
		_tmp4__length1 = self->priv->lights_length1;
		_tmp4__length2 = self->priv->lights_length2;
		_tmp5_ = _tmp4_[((((gint) x) - 1) * _tmp4__length2) + ((gint) y)];
		_tmp6_ = timeline;
		light_toggle_pixel (_tmp5_, _tmp6_);
	}
	if ((((gint) y) + 1) < BOARD_VIEW_size) {
		Light** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		Light* _tmp8_;
		ClutterTimeline* _tmp9_;
		_tmp7_ = self->priv->lights;
		_tmp7__length1 = self->priv->lights_length1;
		_tmp7__length2 = self->priv->lights_length2;
		_tmp8_ = _tmp7_[(((gint) x) * _tmp7__length2) + (((gint) y) + 1)];
		_tmp9_ = timeline;
		light_toggle_pixel (_tmp8_, _tmp9_);
	}
	if ((((gint) y) - 1) >= 0) {
		Light** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		Light* _tmp11_;
		ClutterTimeline* _tmp12_;
		_tmp10_ = self->priv->lights;
		_tmp10__length1 = self->priv->lights_length1;
		_tmp10__length2 = self->priv->lights_length2;
		_tmp11_ = _tmp10_[(((gint) x) * _tmp10__length2) + (((gint) y) - 1)];
		_tmp12_ = timeline;
		light_toggle_pixel (_tmp11_, _tmp12_);
	}
	_tmp13_ = self->priv->lights;
	_tmp13__length1 = self->priv->lights_length1;
	_tmp13__length2 = self->priv->lights_length2;
	_tmp14_ = _tmp13_[(((gint) x) * _tmp13__length2) + ((gint) y)];
	_tmp15_ = timeline;
	light_toggle_pixel (_tmp14_, _tmp15_);
	if (animate) {
		ClutterTimeline* _tmp16_;
		_tmp16_ = timeline;
		clutter_timeline_start (_tmp16_);
	}
	_g_object_unref0 (timeline);
}

static PuzzleGenerator*
board_view_clutter_real_get_puzzle_generator (BoardView* base)
{
	BoardViewClutter * self;
	PuzzleGenerator* _tmp0_;
	PuzzleGenerator* _tmp1_;
	PuzzleGenerator* result = NULL;
	self = (BoardViewClutter*) base;
	_tmp0_ = self->priv->puzzle_generator;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static void
board_view_clutter_real_clear_level (BoardView* base)
{
	BoardViewClutter * self;
	self = (BoardViewClutter*) base;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(x < BOARD_VIEW_size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							Light** _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							Light* _tmp5_;
							if (!_tmp2_) {
								gint _tmp3_;
								_tmp3_ = y;
								y = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(y < BOARD_VIEW_size)) {
								break;
							}
							_tmp4_ = self->priv->lights;
							_tmp4__length1 = self->priv->lights_length1;
							_tmp4__length2 = self->priv->lights_length2;
							_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
							light_set_is_lit (_tmp5_, FALSE);
						}
					}
				}
			}
		}
	}
}

static gboolean
board_view_clutter_real_is_light_active (BoardView* base,
                                         gint x,
                                         gint y)
{
	BoardViewClutter * self;
	Light** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Light* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
	self = (BoardViewClutter*) base;
	_tmp0_ = self->priv->lights;
	_tmp0__length1 = self->priv->lights_length1;
	_tmp0__length2 = self->priv->lights_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = light_get_is_lit (_tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_;
	return result;
}

static GObject*
board_view_clutter_real_get_light_at (BoardView* base,
                                      gint x,
                                      gint y)
{
	BoardViewClutter * self;
	Light** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Light* _tmp1_;
	GObject* _tmp2_;
	GObject* result = NULL;
	self = (BoardViewClutter*) base;
	_tmp0_ = self->priv->lights;
	_tmp0__length1 = self->priv->lights_length1;
	_tmp0__length2 = self->priv->lights_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = _g_object_ref0 ((GObject*) _tmp1_);
	result = _tmp2_;
	return result;
}

static void
board_view_clutter_real_increase_moves (BoardView* base)
{
	BoardViewClutter * self;
	self = (BoardViewClutter*) base;
	self->priv->_moves = self->priv->_moves + 1;
}

gint
board_view_clutter_get_moves (BoardViewClutter* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_moves;
	return result;
}

static void
board_view_clutter_class_init (BoardViewClutterClass * klass,
                               gpointer klass_data)
{
	board_view_clutter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BoardViewClutter_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_board_view_clutter_get_property;
	G_OBJECT_CLASS (klass)->finalize = board_view_clutter_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOARD_VIEW_CLUTTER_MOVES_PROPERTY, board_view_clutter_properties[BOARD_VIEW_CLUTTER_MOVES_PROPERTY] = g_param_spec_int ("moves", "moves", "moves", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
board_view_clutter_board_view_interface_init (BoardViewIface * iface,
                                              gpointer iface_data)
{
	board_view_clutter_board_view_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_moves = (gint (*) (BoardView*)) board_view_clutter_real_get_moves;
	iface->toggle_light = (void (*) (BoardView*, gint, gint, gboolean)) board_view_clutter_real_toggle_light;
	iface->get_puzzle_generator = (PuzzleGenerator* (*) (BoardView*)) board_view_clutter_real_get_puzzle_generator;
	iface->clear_level = (void (*) (BoardView*)) board_view_clutter_real_clear_level;
	iface->is_light_active = (gboolean (*) (BoardView*, gint, gint)) board_view_clutter_real_is_light_active;
	iface->get_light_at = (GObject* (*) (BoardView*, gint, gint)) board_view_clutter_real_get_light_at;
	iface->increase_moves = (void (*) (BoardView*)) board_view_clutter_real_increase_moves;
}

static void
board_view_clutter_instance_init (BoardViewClutter * self,
                                  gpointer klass)
{
	self->priv = board_view_clutter_get_instance_private (self);
	self->playable = TRUE;
	self->priv->_moves = 0;
}

static void
board_view_clutter_finalize (GObject * obj)
{
	BoardViewClutter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOARD_VIEW_CLUTTER, BoardViewClutter);
	_g_object_unref0 (self->priv->puzzle_generator);
	_g_object_unref0 (self->priv->off_texture);
	_g_object_unref0 (self->priv->on_texture);
	self->priv->lights = (_vala_array_free (self->priv->lights, self->priv->lights_length1 * self->priv->lights_length2, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (board_view_clutter_parent_class)->finalize (obj);
}

static GType
board_view_clutter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoardViewClutterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) board_view_clutter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoardViewClutter), 0, (GInstanceInitFunc) board_view_clutter_instance_init, NULL };
	static const GInterfaceInfo board_view_info = { (GInterfaceInitFunc) board_view_clutter_board_view_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType board_view_clutter_type_id;
	board_view_clutter_type_id = g_type_register_static (clutter_group_get_type (), "BoardViewClutter", &g_define_type_info, 0);
	g_type_add_interface_static (board_view_clutter_type_id, TYPE_BOARD_VIEW, &board_view_info);
	BoardViewClutter_private_offset = g_type_add_instance_private (board_view_clutter_type_id, sizeof (BoardViewClutterPrivate));
	return board_view_clutter_type_id;
}

GType
board_view_clutter_get_type (void)
{
	static volatile gsize board_view_clutter_type_id__volatile = 0;
	if (g_once_init_enter (&board_view_clutter_type_id__volatile)) {
		GType board_view_clutter_type_id;
		board_view_clutter_type_id = board_view_clutter_get_type_once ();
		g_once_init_leave (&board_view_clutter_type_id__volatile, board_view_clutter_type_id);
	}
	return board_view_clutter_type_id__volatile;
}

static void
_vala_board_view_clutter_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	BoardViewClutter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOARD_VIEW_CLUTTER, BoardViewClutter);
	switch (property_id) {
		case BOARD_VIEW_CLUTTER_MOVES_PROPERTY:
		g_value_set_int (value, board_view_clutter_get_moves (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

