/* game-view-clutter.c generated by valac 0.48.6, the Vala compiler
 * generated from game-view-clutter.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <clutter/clutter.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"
#include <librsvg/rsvg.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cogl/cogl.h>
#include <float.h>
#include <math.h>

#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_GAME_VIEW, GameViewIface))

typedef struct _GameView GameView;
typedef struct _GameViewIface GameViewIface;

#define TYPE_BOARD_VIEW (board_view_get_type ())
#define BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW, BoardView))
#define IS_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW))
#define BOARD_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BOARD_VIEW, BoardViewIface))

typedef struct _BoardView BoardView;
typedef struct _BoardViewIface BoardViewIface;

#define TYPE_PUZZLE_GENERATOR (puzzle_generator_get_type ())
#define PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGenerator))
#define PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))
#define IS_PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_GENERATOR))
#define IS_PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_GENERATOR))
#define PUZZLE_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))

typedef struct _PuzzleGenerator PuzzleGenerator;
typedef struct _PuzzleGeneratorClass PuzzleGeneratorClass;
typedef enum  {
	GAME_VIEW_REPLACE_STYLE_REFRESH,
	GAME_VIEW_REPLACE_STYLE_SLIDE_FORWARD,
	GAME_VIEW_REPLACE_STYLE_SLIDE_BACKWARD,
	GAME_VIEW_REPLACE_STYLE_SLIDE_NEXT
} GameViewReplaceStyle;

#define GAME_VIEW_TYPE_REPLACE_STYLE (game_view_replace_style_get_type ())

#define TYPE_CLUTTER_GAME_VIEW (clutter_game_view_get_type ())
#define CLUTTER_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLUTTER_GAME_VIEW, ClutterGameView))
#define CLUTTER_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLUTTER_GAME_VIEW, ClutterGameViewClass))
#define IS_CLUTTER_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLUTTER_GAME_VIEW))
#define IS_CLUTTER_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLUTTER_GAME_VIEW))
#define CLUTTER_GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLUTTER_GAME_VIEW, ClutterGameViewClass))

typedef struct _ClutterGameView ClutterGameView;
typedef struct _ClutterGameViewClass ClutterGameViewClass;
typedef struct _ClutterGameViewPrivate ClutterGameViewPrivate;

#define TYPE_BOARD_VIEW_CLUTTER (board_view_clutter_get_type ())
#define BOARD_VIEW_CLUTTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW_CLUTTER, BoardViewClutter))
#define BOARD_VIEW_CLUTTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD_VIEW_CLUTTER, BoardViewClutterClass))
#define IS_BOARD_VIEW_CLUTTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW_CLUTTER))
#define IS_BOARD_VIEW_CLUTTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD_VIEW_CLUTTER))
#define BOARD_VIEW_CLUTTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD_VIEW_CLUTTER, BoardViewClutterClass))

typedef struct _BoardViewClutter BoardViewClutter;
typedef struct _BoardViewClutterClass BoardViewClutterClass;
enum  {
	CLUTTER_GAME_VIEW_0_PROPERTY,
	CLUTTER_GAME_VIEW_NUM_PROPERTIES
};
static GParamSpec* clutter_game_view_properties[CLUTTER_GAME_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BoardViewClutterPrivate BoardViewClutterPrivate;
typedef struct _Block1Data Block1Data;

struct _BoardViewIface {
	GTypeInterface parent_iface;
	gint (*get_moves) (BoardView* self);
	PuzzleGenerator* (*get_puzzle_generator) (BoardView* self);
	void (*clear_level) (BoardView* self);
	void (*toggle_light) (BoardView* self, gint x, gint y, gboolean user_initiated);
	void (*increase_moves) (BoardView* self);
	gboolean (*is_light_active) (BoardView* self, gint x, gint y);
	GObject* (*get_light_at) (BoardView* self, gint x, gint y);
};

struct _GameViewIface {
	GTypeInterface parent_iface;
	void (*replace_board) (GameView* self, BoardView* board_biew, BoardView* new_board_view, GameViewReplaceStyle style, gboolean fast);
	gboolean (*hide_cursor) (GameView* self);
	gboolean (*activate_cursor) (GameView* self);
	gboolean (*move_cursor) (GameView* self, gint x, gint y);
	void (*reset_game) (GameView* self);
	BoardView* (*get_board_view) (GameView* self);
	gboolean (*is_transitioning) (GameView* self);
	gint (*next_level) (GameView* self, gint direction);
	BoardView* (*create_board_view) (GameView* self, gint level);
};

struct _ClutterGameView {
	ClutterGroup parent_instance;
	ClutterGameViewPrivate * priv;
};

struct _ClutterGameViewClass {
	ClutterGroupClass parent_class;
};

struct _ClutterGameViewPrivate {
	ClutterActor* off_texture;
	ClutterActor* on_texture;
	gint current_level;
	GList* actor_remove_queue;
	ClutterActor* board_group;
	BoardViewClutter* board_view;
	ClutterActor* key_cursor_view;
	ClutterTimeline* timeline;
	gint key_cursor_x;
	gint key_cursor_y;
	gboolean key_cursor_ready;
	gint last_direction;
	gint last_sign;
};

struct _BoardViewClutter {
	ClutterGroup parent_instance;
	BoardViewClutterPrivate * priv;
	gboolean playable;
};

struct _BoardViewClutterClass {
	ClutterGroupClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	ClutterGameView* self;
	BoardViewClutter* new_board_view;
	BoardViewClutter* old_board_view;
};

static gint ClutterGameView_private_offset;
static gpointer clutter_game_view_parent_class = NULL;
static GameViewIface * clutter_game_view_game_view_parent_iface = NULL;

void setup_animation (ClutterActor* actor,
                      ClutterAnimationMode mode,
                      guint duration);
GType puzzle_generator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleGenerator, g_object_unref)
GType board_view_get_type (void) G_GNUC_CONST;
GType game_view_replace_style_get_type (void) G_GNUC_CONST;
GType game_view_get_type (void) G_GNUC_CONST;
GType clutter_game_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ClutterGameView, g_object_unref)
GType board_view_clutter_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoardViewClutter, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static ClutterActor* clutter_game_view_build_from_file (ClutterGameView* self,
                                                 const gchar* filename,
                                                 GError** error);
ClutterGameView* clutter_game_view_new (gint level);
ClutterGameView* clutter_game_view_construct (GType object_type,
                                              gint level);
BoardView* game_view_create_board_view (GameView* self,
                                        gint level);
#define BOARD_VIEW_size 5
static BoardView* clutter_game_view_real_create_board_view (GameView* base,
                                                     gint level);
BoardViewClutter* board_view_clutter_new (ClutterActor* off_texture,
                                          ClutterActor* on_texture);
BoardViewClutter* board_view_clutter_construct (GType object_type,
                                                ClutterActor* off_texture,
                                                ClutterActor* on_texture);
void board_view_load_level (BoardView* self,
                            gint level);
static void __lambda7_ (ClutterGameView* self);
void game_view_game_won_cb (GameView* self);
static void ___lambda7__board_view_game_won (BoardView* _sender,
                                      gpointer self);
void game_view_light_toggled_cb (GameView* self);
static void _game_view_light_toggled_cb_board_view_light_toggled (BoardView* _sender,
                                                           gpointer self);
static void clutter_game_view_board_replaced (ClutterGameView* self,
                                       BoardViewClutter* old_view,
                                       BoardViewClutter* new_view);
static void clutter_game_view_real_replace_board (GameView* base,
                                           BoardView* old_board,
                                           BoardView* new_board,
                                           GameViewReplaceStyle style,
                                           gboolean fast);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
void board_view_clutter_slide_in (BoardViewClutter* self,
                                  gint direction,
                                  gint sign,
                                  ClutterTimeline* timeline);
void board_view_clutter_slide_out (BoardViewClutter* self,
                                   gint direction,
                                   gint sign,
                                   ClutterTimeline* timeline);
static void __lambda8_ (Block1Data* _data1_);
static void ___lambda8__clutter_timeline_completed (ClutterTimeline* _sender,
                                             gpointer self);
static gboolean clutter_game_view_real_hide_cursor (GameView* base);
static gboolean clutter_game_view_real_move_cursor (GameView* base,
                                             gint x_step,
                                             gint y_step);
void board_view_clutter_get_light_position (BoardViewClutter* self,
                                            gint x,
                                            gint y,
                                            gfloat* xx,
                                            gfloat* yy);
static gboolean clutter_game_view_real_activate_cursor (GameView* base);
void board_view_move_to (BoardView* self,
                         gint x,
                         gint y);
static void clutter_game_view_real_reset_game (GameView* base);
gboolean game_view_is_transitioning (GameView* self);
void game_view_replace_board (GameView* self,
                              BoardView* board_biew,
                              BoardView* new_board_view,
                              GameViewReplaceStyle style,
                              gboolean fast);
BoardView* game_view_get_board_view (GameView* self);
static BoardView* clutter_game_view_real_get_board_view (GameView* base);
static gint clutter_game_view_real_next_level (GameView* base,
                                        gint direction);
static gboolean clutter_game_view_real_is_transitioning (GameView* base);
static void clutter_game_view_finalize (GObject * obj);
static GType clutter_game_view_get_type_once (void);

void
setup_animation (ClutterActor* actor,
                 ClutterAnimationMode mode,
                 guint duration)
{
	g_return_if_fail (actor != NULL);
	clutter_actor_set_easing_duration (actor, duration);
	clutter_actor_set_easing_mode (actor, mode);
}

static inline gpointer
clutter_game_view_get_instance_private (ClutterGameView* self)
{
	return G_STRUCT_MEMBER_P (self, ClutterGameView_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static ClutterActor*
clutter_game_view_build_from_file (ClutterGameView* self,
                                   const gchar* filename,
                                   GError** error)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	RsvgHandle* handle = NULL;
	const gchar* _tmp1_;
	RsvgHandle* _tmp2_;
	GdkPixbuf* pixbuf = NULL;
	RsvgHandle* _tmp3_;
	GdkPixbuf* _tmp4_;
	ClutterImage* image = NULL;
	ClutterImage* _tmp5_;
	CoglPixelFormat _tmp6_ = 0;
	GdkPixbuf* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	ClutterImage* _tmp10_;
	GdkPixbuf* _tmp11_;
	guint8* _tmp12_;
	GdkPixbuf* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	GdkPixbuf* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	GdkPixbuf* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	ClutterActor* _result_ = NULL;
	ClutterActor* _tmp22_;
	ClutterActor* _tmp23_;
	ClutterImage* _tmp24_;
	gfloat width = 0.0F;
	gfloat height = 0.0F;
	ClutterImage* _tmp25_;
	gfloat _tmp26_ = 0.0F;
	gfloat _tmp27_ = 0.0F;
	ClutterActor* _tmp28_;
	ClutterActor* _tmp29_;
	GError* _inner_error0_ = NULL;
	ClutterActor* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (filename != NULL, NULL);
	_tmp0_ = g_build_filename (DATADIR, filename, NULL);
	filepath = _tmp0_;
	_tmp1_ = filepath;
	_tmp2_ = rsvg_handle_new_from_file (_tmp1_, &_inner_error0_);
	handle = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (filepath);
		return NULL;
	}
	_tmp3_ = handle;
	_tmp4_ = rsvg_handle_get_pixbuf (_tmp3_);
	pixbuf = _tmp4_;
	_tmp5_ = (ClutterImage*) clutter_image_new ();
	image = _tmp5_;
	_tmp7_ = pixbuf;
	_tmp8_ = gdk_pixbuf_get_has_alpha (_tmp7_);
	_tmp9_ = _tmp8_;
	if (_tmp9_) {
		_tmp6_ = COGL_PIXEL_FORMAT_RGBA_8888;
	} else {
		_tmp6_ = COGL_PIXEL_FORMAT_RGB_888;
	}
	_tmp10_ = image;
	_tmp11_ = pixbuf;
	_tmp12_ = gdk_pixbuf_get_pixels (_tmp11_);
	_tmp13_ = pixbuf;
	_tmp14_ = gdk_pixbuf_get_width (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = pixbuf;
	_tmp17_ = gdk_pixbuf_get_height (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = pixbuf;
	_tmp20_ = gdk_pixbuf_get_rowstride (_tmp19_);
	_tmp21_ = _tmp20_;
	clutter_image_set_data (_tmp10_, _tmp12_, _tmp6_, (guint) _tmp15_, (guint) _tmp18_, (guint) _tmp21_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (image);
		_g_object_unref0 (pixbuf);
		_g_object_unref0 (handle);
		_g_free0 (filepath);
		return NULL;
	}
	_tmp22_ = clutter_actor_new ();
	g_object_ref_sink (_tmp22_);
	_result_ = _tmp22_;
	_tmp23_ = _result_;
	_tmp24_ = image;
	clutter_actor_set_content (_tmp23_, (ClutterContent*) _tmp24_);
	_tmp25_ = image;
	clutter_content_get_preferred_size ((ClutterContent*) _tmp25_, &_tmp26_, &_tmp27_);
	width = _tmp26_;
	height = _tmp27_;
	_tmp28_ = _result_;
	clutter_actor_set_pivot_point (_tmp28_, 0.5f, 0.5f);
	_tmp29_ = _result_;
	clutter_actor_set_size (_tmp29_, width, height);
	result = _result_;
	_g_object_unref0 (image);
	_g_object_unref0 (pixbuf);
	_g_object_unref0 (handle);
	_g_free0 (filepath);
	return result;
}

ClutterGameView*
clutter_game_view_construct (GType object_type,
                             gint level)
{
	ClutterGameView * self = NULL;
	ClutterActor* _tmp11_;
	ClutterActor* _tmp12_;
	ClutterActor* _tmp13_;
	ClutterActor* _tmp14_;
	ClutterActor* _tmp15_;
	ClutterActor* _tmp16_;
	BoardView* _tmp17_;
	BoardViewClutter* _tmp18_;
	BoardViewClutter* _tmp19_;
	ClutterActor* _tmp20_;
	BoardViewClutter* _tmp21_;
	gfloat real_board_width = 0.0F;
	ClutterActor* _tmp22_;
	gfloat _tmp23_;
	gfloat _tmp24_;
	gfloat real_board_height = 0.0F;
	ClutterActor* _tmp25_;
	gfloat _tmp26_;
	gfloat _tmp27_;
	ClutterActor* _tmp28_;
	ClutterActor* _tmp29_;
	ClutterActor* _tmp30_;
	ClutterActor* _tmp31_;
	gfloat _tmp32_;
	gfloat _tmp33_;
	ClutterActor* _tmp34_;
	gfloat _tmp35_;
	gfloat _tmp36_;
	ClutterActor* _tmp37_;
	GError* _inner_error0_ = NULL;
	self = (ClutterGameView*) g_object_new (object_type, NULL);
	{
		ClutterActor* _tmp0_ = NULL;
		ClutterActor* _tmp1_;
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_ = NULL;
		ClutterActor* _tmp4_;
		ClutterActor* _tmp5_;
		ClutterActor* _tmp6_ = NULL;
		ClutterActor* _tmp7_;
		ClutterActor* _tmp8_;
		_tmp1_ = clutter_game_view_build_from_file (self, "highlight.svg", &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->key_cursor_view);
		self->priv->key_cursor_view = _tmp2_;
		_tmp4_ = clutter_game_view_build_from_file (self, "on.svg", &_inner_error0_);
		_tmp3_ = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp5_ = _tmp3_;
		_tmp3_ = NULL;
		_g_object_unref0 (self->priv->on_texture);
		self->priv->on_texture = _tmp5_;
		_tmp7_ = clutter_game_view_build_from_file (self, "off.svg", &_inner_error0_);
		_tmp6_ = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp3_);
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp8_ = _tmp6_;
		_tmp6_ = NULL;
		_g_object_unref0 (self->priv->off_texture);
		self->priv->off_texture = _tmp8_;
		_g_object_unref0 (_tmp6_);
		_g_object_unref0 (_tmp3_);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_warning ("game-view-clutter.vala:70: Failed to load images: %s", _tmp10_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp11_ = self->priv->off_texture;
	clutter_actor_hide (_tmp11_);
	_tmp12_ = self->priv->off_texture;
	clutter_actor_add_child ((ClutterActor*) self, _tmp12_);
	_tmp13_ = self->priv->on_texture;
	clutter_actor_hide (_tmp13_);
	_tmp14_ = self->priv->on_texture;
	clutter_actor_add_child ((ClutterActor*) self, _tmp14_);
	_tmp15_ = clutter_actor_new ();
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->board_group);
	self->priv->board_group = _tmp15_;
	_tmp16_ = self->priv->board_group;
	clutter_actor_add_child ((ClutterActor*) self, _tmp16_);
	_tmp17_ = game_view_create_board_view ((GameView*) self, level);
	_tmp18_ = IS_BOARD_VIEW_CLUTTER (_tmp17_) ? ((BoardViewClutter*) _tmp17_) : NULL;
	if (_tmp18_ == NULL) {
		_g_object_unref0 (_tmp17_);
	}
	_g_object_unref0 (self->priv->board_view);
	self->priv->board_view = _tmp18_;
	_tmp19_ = self->priv->board_view;
	_tmp19_->playable = TRUE;
	_tmp20_ = self->priv->board_group;
	_tmp21_ = self->priv->board_view;
	clutter_actor_add_child (_tmp20_, (ClutterActor*) _tmp21_);
	_tmp22_ = self->priv->off_texture;
	_tmp23_ = clutter_actor_get_width (_tmp22_);
	_tmp24_ = _tmp23_;
	real_board_width = (BOARD_VIEW_size * _tmp24_) + 4;
	_tmp25_ = self->priv->off_texture;
	_tmp26_ = clutter_actor_get_height (_tmp25_);
	_tmp27_ = _tmp26_;
	real_board_height = (BOARD_VIEW_size * _tmp27_) + 4;
	clutter_actor_set_size ((ClutterActor*) self, real_board_width, real_board_height);
	_tmp28_ = self->priv->key_cursor_view;
	clutter_actor_set_pivot_point (_tmp28_, 0.5f, 0.5f);
	_tmp29_ = self->priv->key_cursor_view;
	clutter_actor_set_position (_tmp29_, (gfloat) -100, (gfloat) -100);
	_tmp30_ = self->priv->key_cursor_view;
	_tmp31_ = self->priv->off_texture;
	_tmp32_ = clutter_actor_get_width (_tmp31_);
	_tmp33_ = _tmp32_;
	_tmp34_ = self->priv->off_texture;
	_tmp35_ = clutter_actor_get_height (_tmp34_);
	_tmp36_ = _tmp35_;
	clutter_actor_set_size (_tmp30_, _tmp33_, _tmp36_);
	_tmp37_ = self->priv->key_cursor_view;
	clutter_actor_add_child ((ClutterActor*) self, _tmp37_);
	return self;
}

ClutterGameView*
clutter_game_view_new (gint level)
{
	return clutter_game_view_construct (TYPE_CLUTTER_GAME_VIEW, level);
}

static void
__lambda7_ (ClutterGameView* self)
{
	game_view_game_won_cb ((GameView*) self);
}

static void
___lambda7__board_view_game_won (BoardView* _sender,
                                 gpointer self)
{
	__lambda7_ ((ClutterGameView*) self);
}

static void
_game_view_light_toggled_cb_board_view_light_toggled (BoardView* _sender,
                                                      gpointer self)
{
	game_view_light_toggled_cb ((GameView*) self);
}

static BoardView*
clutter_game_view_real_create_board_view (GameView* base,
                                          gint level)
{
	ClutterGameView * self;
	BoardViewClutter* view = NULL;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	BoardViewClutter* _tmp2_;
	BoardView* result = NULL;
	self = (ClutterGameView*) base;
	self->priv->current_level = level;
	_tmp0_ = self->priv->off_texture;
	_tmp1_ = self->priv->on_texture;
	_tmp2_ = board_view_clutter_new (_tmp0_, _tmp1_);
	g_object_ref_sink (_tmp2_);
	view = _tmp2_;
	board_view_load_level ((BoardView*) view, level);
	g_signal_connect_object ((BoardView*) view, "game-won", (GCallback) ___lambda7__board_view_game_won, self, 0);
	g_signal_connect_object ((BoardView*) view, "light-toggled", (GCallback) _game_view_light_toggled_cb_board_view_light_toggled, (GameView*) self, 0);
	view->playable = FALSE;
	result = (BoardView*) view;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
clutter_game_view_board_replaced (ClutterGameView* self,
                                  BoardViewClutter* old_view,
                                  BoardViewClutter* new_view)
{
	GList* _tmp0_;
	BoardViewClutter* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (old_view != NULL);
	g_return_if_fail (new_view != NULL);
	clutter_actor_destroy ((ClutterActor*) old_view);
	_tmp0_ = self->priv->actor_remove_queue;
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
		actor_collection = _tmp0_;
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
			ClutterActor* _tmp1_;
			ClutterActor* actor = NULL;
			_tmp1_ = _g_object_ref0 ((ClutterActor*) actor_it->data);
			actor = _tmp1_;
			{
				ClutterActor* _tmp2_;
				_tmp2_ = actor;
				clutter_actor_destroy (_tmp2_);
				_g_object_unref0 (actor);
			}
		}
	}
	(self->priv->actor_remove_queue == NULL) ? NULL : (self->priv->actor_remove_queue = (_g_list_free__g_object_unref0_ (self->priv->actor_remove_queue), NULL));
	self->priv->actor_remove_queue = NULL;
	new_view->playable = TRUE;
	_g_object_unref0 (self->priv->timeline);
	self->priv->timeline = NULL;
	_tmp3_ = _g_object_ref0 (new_view);
	_g_object_unref0 (self->priv->board_view);
	self->priv->board_view = _tmp3_;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		ClutterGameView* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->old_board_view);
		_g_object_unref0 (_data1_->new_board_view);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda8_ (Block1Data* _data1_)
{
	ClutterGameView* self;
	BoardViewClutter* _tmp0_;
	BoardViewClutter* _tmp1_;
	self = _data1_->self;
	_tmp0_ = _data1_->old_board_view;
	_tmp1_ = _data1_->new_board_view;
	clutter_game_view_board_replaced (self, _tmp0_, _tmp1_);
}

static void
___lambda8__clutter_timeline_completed (ClutterTimeline* _sender,
                                        gpointer self)
{
	__lambda8_ (self);
}

static void
clutter_game_view_real_replace_board (GameView* base,
                                      BoardView* old_board,
                                      BoardView* new_board,
                                      GameViewReplaceStyle style,
                                      gboolean fast)
{
	ClutterGameView * self;
	Block1Data* _data1_;
	gint _tmp0_ = 0;
	ClutterTimeline* _tmp1_;
	ClutterActor* _tmp2_;
	gint direction = 0;
	BoardViewClutter* _tmp3_;
	BoardViewClutter* _tmp4_;
	ClutterTimeline* _tmp31_;
	self = (ClutterGameView*) base;
	g_return_if_fail (old_board != NULL);
	g_return_if_fail (new_board != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	if (fast) {
		_tmp0_ = 500;
	} else {
		_tmp0_ = 1500;
	}
	_tmp1_ = clutter_timeline_new ((guint) _tmp0_);
	_g_object_unref0 (self->priv->timeline);
	self->priv->timeline = _tmp1_;
	_tmp2_ = self->priv->board_group;
	clutter_actor_add_child (_tmp2_, (ClutterActor*) (G_TYPE_CHECK_INSTANCE_TYPE (new_board, clutter_group_get_type ()) ? ((ClutterGroup*) new_board) : NULL));
	direction = 1;
	_tmp3_ = _g_object_ref0 (IS_BOARD_VIEW_CLUTTER (new_board) ? ((BoardViewClutter*) new_board) : NULL);
	_data1_->new_board_view = _tmp3_;
	_tmp4_ = _g_object_ref0 (IS_BOARD_VIEW_CLUTTER (old_board) ? ((BoardViewClutter*) old_board) : NULL);
	_data1_->old_board_view = _tmp4_;
	switch (style) {
		case GAME_VIEW_REPLACE_STYLE_REFRESH:
		{
			BoardViewClutter* _tmp5_;
			BoardViewClutter* _tmp6_;
			BoardViewClutter* _tmp7_;
			ClutterTimeline* _tmp8_;
			BoardViewClutter* _tmp9_;
			ClutterTimeline* _tmp10_;
			_tmp5_ = _data1_->new_board_view;
			clutter_actor_set_z_position ((ClutterActor*) _tmp5_, (gfloat) 250);
			_tmp6_ = _data1_->new_board_view;
			clutter_actor_set_opacity ((ClutterActor*) _tmp6_, (guint) 0);
			_tmp7_ = _data1_->old_board_view;
			_tmp8_ = self->priv->timeline;
			clutter_actor_animate_with_timeline ((ClutterActor*) _tmp7_, (gulong) CLUTTER_EASE_IN_SINE, _tmp8_, "z_position", 250.0 * -1, "opacity", 0, NULL);
			_tmp9_ = _data1_->new_board_view;
			_tmp10_ = self->priv->timeline;
			clutter_actor_animate_with_timeline ((ClutterActor*) _tmp9_, (gulong) CLUTTER_EASE_IN_SINE, _tmp10_, "opacity", 255, "z_position", 0.0, NULL);
			break;
		}
		case GAME_VIEW_REPLACE_STYLE_SLIDE_NEXT:
		{
			gint sign = 0;
			ClutterTimeline* _tmp14_;
			BoardViewClutter* _tmp15_;
			ClutterTimeline* _tmp16_;
			BoardViewClutter* _tmp17_;
			ClutterTimeline* _tmp18_;
			direction = 0;
			sign = 0;
			{
				gboolean _tmp11_ = FALSE;
				_tmp11_ = TRUE;
				while (TRUE) {
					gint _tmp13_ = 0;
					if (!_tmp11_) {
						gboolean _tmp12_ = FALSE;
						if (self->priv->last_direction == direction) {
							_tmp12_ = self->priv->last_sign == sign;
						} else {
							_tmp12_ = FALSE;
						}
						if (!_tmp12_) {
							break;
						}
					}
					_tmp11_ = FALSE;
					direction = (gint) g_random_int_range ((gint32) 0, (gint32) 2);
					if (g_random_boolean ()) {
						_tmp13_ = 1;
					} else {
						_tmp13_ = -1;
					}
					sign = _tmp13_;
				}
			}
			self->priv->last_direction = direction;
			self->priv->last_sign = sign;
			_tmp14_ = clutter_timeline_new ((guint) 1500);
			_g_object_unref0 (self->priv->timeline);
			self->priv->timeline = _tmp14_;
			_tmp15_ = _data1_->new_board_view;
			_tmp16_ = self->priv->timeline;
			board_view_clutter_slide_in (_tmp15_, direction, sign, _tmp16_);
			_tmp17_ = _data1_->old_board_view;
			_tmp18_ = self->priv->timeline;
			board_view_clutter_slide_out (_tmp17_, direction, sign, _tmp18_);
			break;
		}
		case GAME_VIEW_REPLACE_STYLE_SLIDE_FORWARD:
		{
			BoardViewClutter* _tmp19_;
			BoardViewClutter* _tmp20_;
			BoardViewClutter* _tmp21_;
			ClutterTimeline* _tmp22_;
			BoardViewClutter* _tmp23_;
			ClutterTimeline* _tmp24_;
			_tmp19_ = _data1_->new_board_view;
			clutter_actor_set_z_position ((ClutterActor*) _tmp19_, (gfloat) (-250 * direction));
			_tmp20_ = _data1_->new_board_view;
			clutter_actor_set_opacity ((ClutterActor*) _tmp20_, (guint) 0);
			_tmp21_ = _data1_->old_board_view;
			_tmp22_ = self->priv->timeline;
			clutter_actor_animate_with_timeline ((ClutterActor*) _tmp21_, (gulong) CLUTTER_EASE_IN_SINE, _tmp22_, "z_position", 250.0 * direction, "opacity", 0, NULL);
			_tmp23_ = _data1_->new_board_view;
			_tmp24_ = self->priv->timeline;
			clutter_actor_animate_with_timeline ((ClutterActor*) _tmp23_, (gulong) CLUTTER_EASE_IN_SINE, _tmp24_, "opacity", 255, "z_position", 0.0, NULL);
			break;
		}
		case GAME_VIEW_REPLACE_STYLE_SLIDE_BACKWARD:
		{
			BoardViewClutter* _tmp25_;
			BoardViewClutter* _tmp26_;
			BoardViewClutter* _tmp27_;
			ClutterTimeline* _tmp28_;
			BoardViewClutter* _tmp29_;
			ClutterTimeline* _tmp30_;
			direction = -1;
			_tmp25_ = _data1_->new_board_view;
			clutter_actor_set_z_position ((ClutterActor*) _tmp25_, (gfloat) (-250 * direction));
			_tmp26_ = _data1_->new_board_view;
			clutter_actor_set_opacity ((ClutterActor*) _tmp26_, (guint) 0);
			_tmp27_ = _data1_->old_board_view;
			_tmp28_ = self->priv->timeline;
			clutter_actor_animate_with_timeline ((ClutterActor*) _tmp27_, (gulong) CLUTTER_EASE_IN_SINE, _tmp28_, "z_position", 250.0 * direction, "opacity", 0, NULL);
			_tmp29_ = _data1_->new_board_view;
			_tmp30_ = self->priv->timeline;
			clutter_actor_animate_with_timeline ((ClutterActor*) _tmp29_, (gulong) CLUTTER_EASE_IN_SINE, _tmp30_, "opacity", 255, "z_position", 0.0, NULL);
			break;
		}
		default:
		{
			break;
		}
	}
	_tmp31_ = self->priv->timeline;
	g_signal_connect_data (_tmp31_, "completed", (GCallback) ___lambda8__clutter_timeline_completed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	g_signal_emit_by_name ((GameView*) self, "level-changed", self->priv->current_level);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static gboolean
clutter_game_view_real_hide_cursor (GameView* base)
{
	ClutterGameView * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	gboolean result = FALSE;
	self = (ClutterGameView*) base;
	_tmp0_ = self->priv->key_cursor_view;
	setup_animation (_tmp0_, CLUTTER_EASE_OUT_SINE, (guint) 250);
	_tmp1_ = self->priv->key_cursor_view;
	clutter_actor_set_opacity (_tmp1_, (guint8) 0);
	self->priv->key_cursor_ready = FALSE;
	result = TRUE;
	return result;
}

static gboolean
clutter_game_view_real_move_cursor (GameView* base,
                                    gint x_step,
                                    gint y_step)
{
	ClutterGameView * self;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	BoardViewClutter* _tmp0_;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	gboolean result = FALSE;
	self = (ClutterGameView*) base;
	if (self->priv->key_cursor_ready) {
		self->priv->key_cursor_x = self->priv->key_cursor_x + x_step;
		self->priv->key_cursor_y = self->priv->key_cursor_y + y_step;
		self->priv->key_cursor_x = MAX (self->priv->key_cursor_x, 0);
		self->priv->key_cursor_x = MIN (self->priv->key_cursor_x, 4);
		self->priv->key_cursor_y = MAX (self->priv->key_cursor_y, 0);
		self->priv->key_cursor_y = MIN (self->priv->key_cursor_y, 4);
	}
	_tmp0_ = self->priv->board_view;
	board_view_clutter_get_light_position (_tmp0_, self->priv->key_cursor_x, self->priv->key_cursor_y, &_tmp1_, &_tmp2_);
	x = _tmp1_;
	y = _tmp2_;
	if (self->priv->key_cursor_ready) {
		ClutterActor* _tmp3_;
		ClutterActor* _tmp4_;
		_tmp3_ = self->priv->key_cursor_view;
		setup_animation (_tmp3_, CLUTTER_EASE_OUT_SINE, (guint) 250);
		_tmp4_ = self->priv->key_cursor_view;
		clutter_actor_set_position (_tmp4_, x + 2, y + 2);
	} else {
		ClutterActor* _tmp5_;
		ClutterActor* _tmp6_;
		ClutterActor* _tmp7_;
		ClutterActor* _tmp8_;
		_tmp5_ = self->priv->key_cursor_view;
		clutter_actor_set_opacity (_tmp5_, (guint) 0);
		_tmp6_ = self->priv->key_cursor_view;
		clutter_actor_set_position (_tmp6_, x + 2, y + 2);
		_tmp7_ = self->priv->key_cursor_view;
		setup_animation (_tmp7_, CLUTTER_EASE_OUT_SINE, (guint) 250);
		_tmp8_ = self->priv->key_cursor_view;
		clutter_actor_set_opacity (_tmp8_, (guint8) 255);
	}
	self->priv->key_cursor_ready = TRUE;
	result = TRUE;
	return result;
}

static gboolean
clutter_game_view_real_activate_cursor (GameView* base)
{
	ClutterGameView * self;
	gboolean result = FALSE;
	self = (ClutterGameView*) base;
	if (self->priv->key_cursor_ready) {
		BoardViewClutter* _tmp0_;
		_tmp0_ = self->priv->board_view;
		board_view_move_to ((BoardView*) _tmp0_, self->priv->key_cursor_x, self->priv->key_cursor_y);
	}
	result = TRUE;
	return result;
}

static void
clutter_game_view_real_reset_game (GameView* base)
{
	ClutterGameView * self;
	BoardView* _tmp0_;
	BoardView* _tmp1_;
	BoardView* _tmp2_;
	BoardView* _tmp3_;
	self = (ClutterGameView*) base;
	if (game_view_is_transitioning ((GameView*) self)) {
		return;
	}
	_tmp0_ = game_view_get_board_view ((GameView*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_view_create_board_view ((GameView*) self, 1);
	_tmp3_ = _tmp2_;
	game_view_replace_board ((GameView*) self, _tmp1_, _tmp3_, GAME_VIEW_REPLACE_STYLE_REFRESH, TRUE);
	_g_object_unref0 (_tmp3_);
	_g_object_unref0 (_tmp1_);
}

static BoardView*
clutter_game_view_real_get_board_view (GameView* base)
{
	ClutterGameView * self;
	BoardViewClutter* _tmp0_;
	BoardView* _tmp1_;
	BoardView* result = NULL;
	self = (ClutterGameView*) base;
	_tmp0_ = self->priv->board_view;
	_tmp1_ = _g_object_ref0 ((BoardView*) _tmp0_);
	result = _tmp1_;
	return result;
}

static gint
clutter_game_view_real_next_level (GameView* base,
                                   gint direction)
{
	ClutterGameView * self;
	gint result = 0;
	self = (ClutterGameView*) base;
	self->priv->current_level = self->priv->current_level + direction;
	result = self->priv->current_level;
	return result;
}

static gboolean
clutter_game_view_real_is_transitioning (GameView* base)
{
	ClutterGameView * self;
	gboolean _tmp0_ = FALSE;
	ClutterTimeline* _tmp1_;
	gboolean result = FALSE;
	self = (ClutterGameView*) base;
	_tmp1_ = self->priv->timeline;
	if (_tmp1_ != NULL) {
		ClutterTimeline* _tmp2_;
		_tmp2_ = self->priv->timeline;
		_tmp0_ = clutter_timeline_is_playing (_tmp2_);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static void
clutter_game_view_class_init (ClutterGameViewClass * klass,
                              gpointer klass_data)
{
	clutter_game_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ClutterGameView_private_offset);
	G_OBJECT_CLASS (klass)->finalize = clutter_game_view_finalize;
}

static void
clutter_game_view_game_view_interface_init (GameViewIface * iface,
                                            gpointer iface_data)
{
	clutter_game_view_game_view_parent_iface = g_type_interface_peek_parent (iface);
	iface->create_board_view = (BoardView* (*) (GameView*, gint)) clutter_game_view_real_create_board_view;
	iface->replace_board = (void (*) (GameView*, BoardView*, BoardView*, GameViewReplaceStyle, gboolean)) clutter_game_view_real_replace_board;
	iface->hide_cursor = (gboolean (*) (GameView*)) clutter_game_view_real_hide_cursor;
	iface->move_cursor = (gboolean (*) (GameView*, gint, gint)) clutter_game_view_real_move_cursor;
	iface->activate_cursor = (gboolean (*) (GameView*)) clutter_game_view_real_activate_cursor;
	iface->reset_game = (void (*) (GameView*)) clutter_game_view_real_reset_game;
	iface->get_board_view = (BoardView* (*) (GameView*)) clutter_game_view_real_get_board_view;
	iface->next_level = (gint (*) (GameView*, gint)) clutter_game_view_real_next_level;
	iface->is_transitioning = (gboolean (*) (GameView*)) clutter_game_view_real_is_transitioning;
}

static void
clutter_game_view_instance_init (ClutterGameView * self,
                                 gpointer klass)
{
	self->priv = clutter_game_view_get_instance_private (self);
	self->priv->actor_remove_queue = NULL;
	self->priv->key_cursor_x = 0;
	self->priv->key_cursor_y = 0;
	self->priv->key_cursor_ready = FALSE;
	self->priv->last_direction = 0;
	self->priv->last_sign = 0;
}

static void
clutter_game_view_finalize (GObject * obj)
{
	ClutterGameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLUTTER_GAME_VIEW, ClutterGameView);
	_g_object_unref0 (self->priv->off_texture);
	_g_object_unref0 (self->priv->on_texture);
	(self->priv->actor_remove_queue == NULL) ? NULL : (self->priv->actor_remove_queue = (_g_list_free__g_object_unref0_ (self->priv->actor_remove_queue), NULL));
	_g_object_unref0 (self->priv->board_group);
	_g_object_unref0 (self->priv->board_view);
	_g_object_unref0 (self->priv->key_cursor_view);
	_g_object_unref0 (self->priv->timeline);
	G_OBJECT_CLASS (clutter_game_view_parent_class)->finalize (obj);
}

static GType
clutter_game_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClutterGameViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clutter_game_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClutterGameView), 0, (GInstanceInitFunc) clutter_game_view_instance_init, NULL };
	static const GInterfaceInfo game_view_info = { (GInterfaceInitFunc) clutter_game_view_game_view_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType clutter_game_view_type_id;
	clutter_game_view_type_id = g_type_register_static (clutter_group_get_type (), "ClutterGameView", &g_define_type_info, 0);
	g_type_add_interface_static (clutter_game_view_type_id, TYPE_GAME_VIEW, &game_view_info);
	ClutterGameView_private_offset = g_type_add_instance_private (clutter_game_view_type_id, sizeof (ClutterGameViewPrivate));
	return clutter_game_view_type_id;
}

GType
clutter_game_view_get_type (void)
{
	static volatile gsize clutter_game_view_type_id__volatile = 0;
	if (g_once_init_enter (&clutter_game_view_type_id__volatile)) {
		GType clutter_game_view_type_id;
		clutter_game_view_type_id = clutter_game_view_get_type_once ();
		g_once_init_leave (&clutter_game_view_type_id__volatile, clutter_game_view_type_id);
	}
	return clutter_game_view_type_id__volatile;
}

